
#include <DHT.h>//librería del sensor DHT11


#include <LiquidCrystal_I2C.h> // libreria para pantalla lcd I2C
LiquidCrystal_I2C lcd(0x27, 16, 2); 


//pines y variables
int sensor = 2;//Pin 2 para el valor del sensor DHT11
int temp, humedad;//variables de temperatura y humedad del DHT11
int boton = 3;//activa manualmente la bomba
const int bomba = 13; //En función de la bomba
const int humedadsuelo = A0; //humedad del suelo (sensor de piso) 

DHT dht (sensor, DHT11);
int botonest = 0; // inicio del estado del boton en cero


void setup()
{
  Serial.begin(9600);//puerto serie a 9600
  dht.begin();//Arranque del sensor DHT11

  //entradas y salidas
  pinMode(humedadsuelo, INPUT);
  pinMode(bomba, OUTPUT);
  pinMode(boton, INPUT);

  //Para la pantalla LCD
  lcd.init(); 
  lcd.backlight(); 
  lcd.clear(); 
  lcd.setCursor(0, 0); 
}

void loop()
{
  int SensorValue = analogRead(humedadsuelo);//Se lee el valor del sensor de piso y se guarda en una variable
  int botonest = digitalRead(boton);//Lee el estado del boton

  //valores de temperatura y humedad 
  humedad = dht.readHumidity();
  temp = dht.readTemperature();

  //Puerto serie
  //Imprime los valores de temperatura y humedad del DHT11
  Serial.print("Temperatura: "); Serial.print(temp);
  Serial.print("ºC Humedad: "); Serial.print(humedad); Serial.println("%");

  //Imprime el valor de la humedad del suelo
  Serial.print("Humedad del suelo: "); Serial.print(SensorValue); Serial.println("%");
  delay(500);


  lcd.init(); 
  lcd.backlight(); 
  lcd.clear();
  lcd.setCursor(0, 0); 
  lcd.print("DHT:");
  lcd.print(temp);
  lcd.print("C/");
  lcd.print(humedad);
  lcd.print("%");
  lcd.setCursor(0, 1); 
  lcd.print("HS:");
  lcd.print(SensorValue);
  lcd.print("%");




    if (SensorValue >= 700) // se ordena regar cuando ell valor leído es mayor o igual que 700
    {
     
      // Riega durante 2 segundoS y espera a comprobar la humedad otro segundo
      Serial.println("La tierra está seca, comienza el riego automático");
      lcd.clear();
      lcd.setCursor(0, 0); 
      lcd.print("Riego automatico");
      lcd.setCursor(0, 1); 
      lcd.print("HS:");
      lcd.print(SensorValue);
      lcd.print("%");
      digitalWrite(bomba, HIGH);
      delay(2000);
      digitalWrite(bomba, LOW);
      delay(1000);

      if (botonest == 0)
      { Serial.println("No se puede activar riego manual. Riego automático activo");
        lcd.clear();
        lcd.setCursor(0, 0); 
        lcd.print("Regando automatico");
        lcd.setCursor(0, 1); 
        lcd.print("NO MANUAL");
        delay(1000);

      }
    }

    if (SensorValue < 700) //No es necesario el riego automático, pero se puede regar de forma manual
    {
      if (botonest == 1) {
        Serial.println("Regando de forma manual");
        lcd.clear();
        lcd.setCursor(0, 0); 
        lcd.print("Riego manual");
        lcd.setCursor(0, 1); 
        lcd.print("HS:");
        lcd.print(SensorValue);
        lcd.print("%");
        digitalWrite(bomba, HIGH);
      }
      if (botonest == 0) {
        digitalWrite(bomba, LOW);
      }
    }
  }
